﻿using Steema.TeeChart;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TChartRotationTest
{
	public partial class Form1 : Form
	{
		private TChart tChart1;
		public Form1()
		{
			InitializeComponent();

			tChart1 = new TChart();
			tChart1.Dock = DockStyle.Fill;
			splitContainer1.Panel2.Controls.Add(tChart1);

			InitializeChart();
		}

		private void InitializeChart()
		{
			Steema.TeeChart.Styles.Surface surfaceSeries1;
			tChart1.Aspect.View3D = true;
			tChart1.Aspect.Orthogonal = false;
			Steema.TeeChart.Tools.Rotate rotate1 = new Steema.TeeChart.Tools.Rotate(tChart1.Chart);

			rotate1.Button = MouseButtons.Right;
			rotate1.Style = Steema.TeeChart.Tools.RotateStyles.All;

			rotate1.Active = true;
			surfaceSeries1 = new Steema.TeeChart.Styles.Surface();
			surfaceSeries1.Visible = true;

			surfaceSeries1.WireFrame = false;
			surfaceSeries1.Pen.Visible = true;

			surfaceSeries1.Clear();
			surfaceSeries1.ClearPalette();
			surfaceSeries1.IrregularGrid = true;

			// bottom axis - pipe length
			Steema.TeeChart.Axis bottomAxis = tChart1.Axes.Bottom;
			bottomAxis.Title.Visible = true;
			bottomAxis.Title.Text = "Pipe length";

			// left axis - property
			Steema.TeeChart.Axis leftAxis = tChart1.Axes.Left;
			leftAxis.Title.Visible = true;
			//leftAxis.Title.Text =

			// depth axis - time
			Steema.TeeChart.Axis depthAxis = tChart1.Axes.Depth;
			depthAxis.Title.Visible = true;
			depthAxis.Title.Text = "Time (s)";

			double X;
			double Y;
			double Z;
			double B1;
			double B2;
			double Xbar;
			double Ybar;


			Xbar = Ybar = 10;
			B1 = B2 = 0.01;

			for (int i = -100; i < 100; i++)
			{
				X = (double)i;
				for (int j = -100; j < 100; j++)
				{
					Y = (double)j;
					Z = Math.Exp(-1 * B1 * (X - Xbar) * (X - Xbar) - 1 * B2 * (Y - Ybar) * (Y - Ybar));
					surfaceSeries1.Add(X, Z, Y);

				}
			}
			tChart1.Series.Add(surfaceSeries1);

			tChart1.Aspect.Elevation = 276;
			tChart1.Aspect.Rotation = 16;

			SetUDElevation(tChart1.Aspect.Elevation);
			SetUDRotation(tChart1.Aspect.Rotation);

			tChart1.BeforeDraw += TChart1_BeforeDraw;
		}

		private void TChart1_BeforeDraw(object sender, Steema.TeeChart.Drawing.Graphics3D g)
		{
			System.Diagnostics.Debug.WriteLine($"Rotation: {tChart1.Aspect.Rotation}");
			System.Diagnostics.Debug.WriteLine($"Elevation: {tChart1.Aspect.Elevation}");
			SetUDElevation(tChart1.Aspect.Elevation);
			SetUDRotation(tChart1.Aspect.Rotation);
		}

		private void SetUDElevation(int newValue)
		{
			if (ud_elevation.Value != newValue)
			{
				ud_elevation.Value = newValue;
			}
		}

		private void SetUDRotation(int newValue)
		{
			if (ud_rotation.Value != newValue)
			{
				ud_rotation.Value = newValue;
			}
		}

		private void ud_elevation_ValueChanged(object sender, EventArgs e)
		{
			if (ud_elevation.Value != tChart1.Aspect.Elevation)
			{
				tChart1.Aspect.Elevation = (int)ud_elevation.Value;
			}
		}

		private void ud_rotation_ValueChanged(object sender, EventArgs e)
		{
			if (ud_rotation.Value != tChart1.Aspect.Rotation)
			{
				tChart1.Aspect.Rotation = (int)ud_rotation.Value;
			}
		}
	}
}
